summaryrefslogtreecommitdiffstats
path: root/development/xvi/xvi.SlackBuild
diff options
context:
space:
mode:
author B. Watson <yalhcru@gmail.com>2018-08-08 18:06:28 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2018-08-11 07:23:06 +0700
commitffffbc85eda024ac83b910393f42c59563cd928b (patch)
tree0ba379333044f213c7e5c2a3f1a19145b37a615f /development/xvi/xvi.SlackBuild
parentdc346489b44f0ce7754c030e7f17609620e752a5 (diff)
downloadslackbuilds-ffffbc85eda024ac83b910393f42c59563cd928b.tar.gz
slackbuilds-ffffbc85eda024ac83b910393f42c59563cd928b.tar.xz
development/xvi: Added (tiny but full-featured vi clone).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'development/xvi/xvi.SlackBuild')
-rw-r--r--development/xvi/xvi.SlackBuild93
1 files changed, 93 insertions, 0 deletions
diff --git a/development/xvi/xvi.SlackBuild b/development/xvi/xvi.SlackBuild
new file mode 100644
index 0000000000..92372a28af
--- /dev/null
+++ b/development/xvi/xvi.SlackBuild
@@ -0,0 +1,93 @@
+#!/bin/sh
+
+# Slackware build script for xvi
+
+# Written by B. Watson (yalhcru@gmail.com)
+
+# Licensed under the WTFPL. See http://www.wtfpl.net/txt/copying/ for details.
+
+PRGNAM=xvi
+VERSION=${VERSION:-2.50.3}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Since the purpose of xvi is to be tiny, let's build a tiny binary
+# with -Os by default (makes the binary ~25% smaller). Upstream also
+# recommends using CC=clang for a smaller binary, but with Slack 14.2's
+# older versions of gcc and clang, gcc -Os actually beats clang -Os by
+# a few KB.
+OPT="${OPT:--Os}"
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="$OPT -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="$OPT -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="$OPT -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+
+
+# Fix man page slightly: "/usr/lib/xvi.helpDefault help file." should
+# get a space before "Default".
+sed -i 's/.Default help file\./\n&/' doc/$PRGNAM.1
+
+if [ "$STATIC" = "yes" ]; then
+ SLKCFLAGS="$SLKCFLAGS -static"
+ BINDIR="$PKG/bin"
+else
+ BINDIR="$PKG/usr/bin"
+fi
+
+# too many \ here for comfortable reading, sorry.
+SLKCFLAGS="$SLKCFLAGS -DHELPFILE=\\\"/usr/share/$PRGNAM/$PRGNAM.help\\\""
+
+make -C src -f makefile.lnx DEBUGFLAG="" OPTFLAG="$SLKCFLAGS"
+
+# there's a 'make install' but it's incomplete and wrong, so:
+install -D -s -m0755 -oroot -groot src/$PRGNAM $BINDIR/$PRGNAM
+install -D -m0644 src/$PRGNAM.help $PKG/usr/share/$PRGNAM/$PRGNAM.help
+mkdir -p $PKG/usr/man/man1
+gzip -9c doc/$PRGNAM.1 > $PKG/usr/man/man1/$PRGNAM.1.gz
+
+# top-level README just has pointers to the other docs, don't need it.
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a doc/README doc/COPYING RELEASE* BUGS issues \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}